/*
    A basic extension of the java.applet.Applet class
 */

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import COM.webconcepts.net.*;

public class QuotronApplet extends Applet {
	URL stockServerUrl;
	HttpProxyConnection stockServerConnection;
	String stockSymbol;
	String companyNameString;
	Thread updateThread;
	int i = 0;

	public void init() {
		super.init();

		stockSymbol = this.getParameter("Symbol");
		companyNameString = this.getParameter("Company");

//        stockSymbol = "MSFT";
//        companyNameString = "Microsoft Corporation";

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(178,60);
		setBackground(new Color(12632256));
		symbolName = new java.awt.Label(stockSymbol);
		symbolName.reshape(6,7,54,33);
		add(symbolName);
		stockSymbolValue = new java.awt.TextField();
		stockSymbolValue.setFont(new Font("Helvetica", Font.BOLD, 10));
		stockSymbolValue.reshape(64,9,48,27);
		add(stockSymbolValue);
		stockDelta = new java.awt.TextField();
		stockDelta.setFont(new Font("Helvetica", Font.BOLD, 10));
		stockDelta.reshape(120,9,48,27);
		add(stockDelta);
		companyName = new java.awt.Label(companyNameString);
		companyName.reshape(6,41,161,20);
		companyName.setFont(new Font("Helvetica", Font.BOLD, 9));
		add(companyName);
		//}}

		// init the stock server connection
		try {
		    stockServerUrl = new URL("http://quote.yahoo.com/d/quotes.csv?symbols=" + stockSymbol + "&format=sl1d1t1c1ohgv&ext=.csv");
    	}
    	catch (Exception e) {
    	    System.out.println("error constructing URL");
    	    e.printStackTrace();
    	}

		// fetch the first stock value
		getStockValue();

		// start the update cycle
		updateThread = new UpdateThread(this);
		updateThread.start();
	}

	public boolean handleEvent(Event event) {
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	Label companyName;
	TextField stockDelta;
	TextField stockSymbolValue;
	Label symbolName;

	public String getStockValue() {
	    InputStream stockData = null;
		try {
			HttpProxyConnection proxyConnection = new HttpProxyConnection(getCodeBase().getHost());
			byte[] buffer = proxyConnection.fetch(stockServerUrl);
			System.out.write(buffer);

            // create a string representing the array
            String dataString = new String(buffer, 0);

            int currentValStart = dataString.indexOf(",");
            int currentValEnd = dataString.indexOf(",", currentValStart + 1);

            int valDeltaStart = dataString.indexOf(",", currentValEnd + 17);
            int valDeltaEnd = dataString.indexOf(",", valDeltaStart + 1);
            String deltaVal = dataString.substring(valDeltaStart + 1, valDeltaEnd);

            stockSymbolValue.setText(dataString.substring(currentValStart + 1, currentValEnd));
            stockDelta.setText(deltaVal);

            if (Float.valueOf(deltaVal).floatValue() < 0.0F) {
                stockDelta.setForeground(Color.red);
            }
            else {
                stockDelta.setForeground(Color.green);
            }

		}
		catch (Exception e) {
		    System.out.println("error fetching stock!");
		    e.printStackTrace();
		    System.exit(1);
		}
		return null;
	}
}

